03-04 创建和编辑AutoCAD实体(四) 编辑二维命名对象 (9)

 

11、Edit Hatches 编辑图案填充

You can edit both hatch boundaries and hatch patterns. If you edit the boundary of an associative hatch, the pattern is updated as long as the editing results in a valid boundary. Associative hatches are updated even if they're on layers that are turned off. You can modify hatch patterns or choose a new pattern for an existing hatch, but associativity can only be set when a hatch is created. You can check to see if a Hatch object is associative by using the Associative property.

我们可以编辑填充边界和填充图案。如果编辑关联填充的边界,且编辑后边界合法,填充图案就会随之更新。即便所在的图层处于关闭状态,关联填充也会更新。我们可以修改填充图案,或为其选择新的填充图案,但是其关联属性只在填充创建时才能设置。我们可以使用Associative属性检查Hatch对象是否为关联的。

You must re-evaluate a hatch using the EvaluateHatch method to see any edits to the hatch.

要想看到编辑后的效果,必须使用EvaluateHatch方法重新对所编辑的填充进行求值。

For more information about editing hatches, see “Modify Hatches and Solid-Filled Areas” in theAutoCAD User's Guide.

更多关于编辑填充的内容,见AutoCAD用户指南中的“修改图案填充和实体填充区域”。

11.1、Edit Hatch Boundaries编辑填充边界

You can append, insert, or remove loops from the boundaries of a Hatch object. Associative hatches are updated to match any changes made to their boundaries. Non-associative hatches are not updated.

我们可以从Hatch对象的边界中追加、插入及删除边界环。关联性填充会更新以适应边界变化,非关联性填充不更新。

To edit a hatch boundary, use one of the following methods:

下列方法用于编辑填充边界:

AppendLoop

Appends a loop to the hatch. You define the type of loop being appended with first parameter of the AppendLoop method and the constants defined by the HatchLoopTypes enum.

给填充追加一个边界环,所追加边界环的类型由AppendLoop方法的第一个参数和HatchLoopTypes枚举类型的常量定义。

GetLoopAt

Gets the loop at a given index of a hatch. 获取填充给定索引位置的边界环。

InsertLoopAt

Inserts a loop at a given index of a hatch. 在填充的给定索引位置插入一个边界环。

RemoveLoopAt

Deletes a loop at a given index of a hatch. 在填充的给定索引位置删除一个边界环。

 

To query a hatch boundary, use one of the following methods:

下列方法用于查询填充的边界:

LoopTypeAt

Gets the type of loop at a given index of a hatch. 获取填充给定索引位置边界环的类型。

NumberOfLoops

Gets the number of loops of a hatch. 获取填充的边界环的个数。

 

Append an inner loop to a hatch 给填充追加一个内部边界环

This example creates an associative hatch. It then creates a circle and appends the circle as an inner loop to the hatch.

本例创建一个关联图案填充,然后创建一个圆并追加该圆作为填充的内部边界环。

 

VB.NET

Imports Autodesk.AutoCAD.Runtime

Imports Autodesk.AutoCAD.ApplicationServices

Imports Autodesk.AutoCAD.DatabaseServices

Imports Autodesk.AutoCAD.Geometry

 

<CommandMethod("EditHatchAppendLoop")> _

Public Sub EditHatchAppendLoop()

  '' Get the current document and database

  Dim acDoc As Document = Application.DocumentManager.MdiActiveDocument

  Dim acCurDb As Database = acDoc.Database

 

  '' Start a transaction

  Using acTrans As Transaction = acCurDb.TransactionManager.StartTransaction()

 

      '' Open the Block table for read

      Dim acBlkTbl As BlockTable

      acBlkTbl = acTrans.GetObject(acCurDb.BlockTableId, _

                                   OpenMode.ForRead)

 

      '' Open the Block table record Model space for write

      Dim acBlkTblRec As BlockTableRecord

      acBlkTblRec = acTrans.GetObject(acBlkTbl(BlockTableRecord.ModelSpace), _

                                      OpenMode.ForWrite)

 

      '' Create an arc object for the closed boundary to hatch

      Dim acArc As Arc = New Arc(New Point3d(5, 3, 0), 3, 0, 3.141592)

 

      acBlkTblRec.AppendEntity(acArc)

      acTrans.AddNewlyCreatedDBObject(acArc, True)

 

      '' Create an line object for the closed boundary to hatch

      Dim acLine As Line = New Line(acArc.StartPoint, acArc.EndPoint)

 

      acBlkTblRec.AppendEntity(acLine)

      acTrans.AddNewlyCreatedDBObject(acLine, True)

 

      '' Adds the arc and line to an object id collection

      Dim acObjIdColl As ObjectIdCollection = New ObjectIdCollection()

      acObjIdColl.Add(acArc.ObjectId)

      acObjIdColl.Add(acLine.ObjectId)

 

      '' Create the hatch object and append it to the block table record

      Dim acHatch As Hatch = New Hatch()

      acBlkTblRec.AppendEntity(acHatch)

      acTrans.AddNewlyCreatedDBObject(acHatch, True)

 

      '' Set the properties of the hatch object

      '' Associative must be set after the hatch object is appended to the

      '' block table record and before AppendLoop

      acHatch.SetHatchPattern(HatchPatternType.PreDefined, "ANSI31")

      acHatch.Associative = True

      acHatch.AppendLoop(HatchLoopTypes.Outermost, acObjIdColl)

 

      '' Create a circle object for the inner boundary of the hatch

      Dim acCirc As Circle = New Circle()

      acCirc.Center = New Point3d(5, 4.5, 0)

      acCirc.Radius = 1

 

      acBlkTblRec.AppendEntity(acCirc)

      acTrans.AddNewlyCreatedDBObject(acCirc, True)

 

      '' Adds the circle to an object id collection

      acObjIdColl.Clear()

      acObjIdColl.Add(acCirc.ObjectId)

 

      '' Append the circle as the inner loop of the hatch and evaluate it

      acHatch.AppendLoop(HatchLoopTypes.Default, acObjIdColl)

      acHatch.EvaluateHatch(True)

 

      '' Save the new object to the database

      acTrans.Commit()

  End Using

End Sub

 

C#

using Autodesk.AutoCAD.Runtime;

using Autodesk.AutoCAD.ApplicationServices;

using Autodesk.AutoCAD.DatabaseServices;

using Autodesk.AutoCAD.Geometry;

 

[CommandMethod("EditHatchAppendLoop")]

public static void EditHatchAppendLoop()

{

  // Get the current document and database获取当前文档和数据库

  Document acDoc = Application.DocumentManager.MdiActiveDocument;

  Database acCurDb = acDoc.Database;

 

  // Start a transaction启动事务

  using (Transaction acTrans = acCurDb.TransactionManager.StartTransaction())

  {

      // Open the Block table for read以读打开块表

      BlockTable acBlkTbl;

      acBlkTbl = acTrans.GetObject(acCurDb.BlockTableId,

                                   OpenMode.ForRead) as BlockTable;

 

      // Open the Block table record Model space for write以写打开块表记录模型空间

      BlockTableRecord acBlkTblRec;

      acBlkTblRec = acTrans.GetObject(acBlkTbl[BlockTableRecord.ModelSpace],

                                      OpenMode.ForWrite) as BlockTableRecord;

 

      // Create an arc object for the closed boundary to hatch创建一个圆弧对象作为填充的闭合边界

      Arc acArc = new Arc(new Point3d(5, 3, 0), 3, 0, 3.141592);

 

      acBlkTblRec.AppendEntity(acArc);

      acTrans.AddNewlyCreatedDBObject(acArc, true);

 

      // Create an line object for the closed boundary to hatch创建一个直线对象作为填充的闭合边界

      Line acLine = new Line(acArc.StartPoint, acArc.EndPoint);

 

      acBlkTblRec.AppendEntity(acLine);

      acTrans.AddNewlyCreatedDBObject(acLine, true);

 

      // Adds the arc and line to an object id collection将圆弧和直线添加到ObjectIdCollection

      ObjectIdCollection acObjIdColl = new ObjectIdCollection();

      acObjIdColl.Add(acArc.ObjectId);

      acObjIdColl.Add(acLine.ObjectId);

 

      // Create the hatch object and append it to the block table record创建Hatch对象

      Hatch acHatch = new Hatch();

      acBlkTblRec.AppendEntity(acHatch);

      acTrans.AddNewlyCreatedDBObject(acHatch, true);

 

      // Set the properties of the hatch object设置填充对象的属性

      // Associative must be set after the hatch object is appended to the

      // block table record and before AppendLoop关联属性必须在将填充对象添加到块表记录之后、执行AppendLoop之前设置

      acHatch.SetHatchPattern(HatchPatternType.PreDefined, "ANSI31");

      acHatch.Associative = true;

      acHatch.AppendLoop(HatchLoopTypes.Outermost, acObjIdColl);

 

      // Create a circle object for the inner boundary of the hatch创建一个圆对象作为填充的内部边界

      Circle acCirc = new Circle();

      acCirc.Center = new Point3d(5, 4.5, 0);

      acCirc.Radius = 1;

 

      acBlkTblRec.AppendEntity(acCirc);

      acTrans.AddNewlyCreatedDBObject(acCirc, true);

 

      // Adds the circle to an object id collection将圆添加到ObjectIdCollection

      acObjIdColl.Clear();

      acObjIdColl.Add(acCirc.ObjectId);

 

      // Append the circle as the inner loop of the hatch and evaluate it追加圆为内部边界环并对填充对象取值

      acHatch.AppendLoop(HatchLoopTypes.Default, acObjIdColl);

      acHatch.EvaluateHatch(true);

 

      // Save the new object to the database保存到数据库

      acTrans.Commit();

  }

}

 

VBA/ActiveX Code Reference

Sub EditHatchAppendLoop()

    Dim hatchObj As AcadHatch

    Dim patternName As String

    Dim PatternType As Long

    Dim bAssociativity As Boolean

 

    ' Define and create the hatch

    patternName = "ANSI31"

    PatternType = 0

    bAssociativity = True

    Set hatchObj = ThisDrawing.ModelSpace. _

                       AddHatch(PatternType, patternName, bAssociativity)

 

    ' Create the outer loop for the hatch.

    Dim outerLoop(0 To 1) As AcadEntity

    Dim center(0 To 2) As Double

    Dim radius As Double

    Dim startAngle As Double

    Dim endAngle As Double

    center(0) = 5: center(1) = 3: center(2) = 0

    radius = 3

    startAngle = 0

    endAngle = 3.141592

    Set outerLoop(0) = ThisDrawing.ModelSpace. _

                           AddArc(center, radius, startAngle, endAngle)

    Set outerLoop(1) = ThisDrawing.ModelSpace. _

                           AddLine(outerLoop(0).startPoint, outerLoop(0).endPoint)

 

    ' Append the outer loop to the hatch object

    hatchObj.AppendOuterLoop (outerLoop)

 

    ' Create a circle as the inner loop for the hatch.

    Dim innerLoop(0) As AcadEntity

    center(0) = 5: center(1) = 4.5: center(2) = 0

    radius = 1

    Set innerLoop(0) = ThisDrawing.ModelSpace. _

                           AddCircle(center, radius)

 

    ' Append the circle as an inner loop to the hatch

    hatchObj.AppendInnerLoop (innerLoop)

 

    ' Evaluate and display the hatch

    hatchObj.Evaluate

    ThisDrawing.Regen True

End Sub

 

11.2、Edit Hatch Patterns编辑填充图案

You can change the angle or spacing of an existing hatch pattern or replace it with a solid-fill, gradient fill, or one of the predefined patterns that AutoCAD offers. The Pattern option in the Boundary Hatch dialog box displays a list of these patterns. To reduce file size, the hatch is defined in the drawing as a single graphic object.

我们可以修改现有填充图案的角度或间隔,或者用实体填充、渐变色填充以及AutoCAD提供的预定义填充图案来替换现有填充图案。边界填充对话框的图案选项显示了这些图案的列表。为减小文件大小,在图形中将填充图案定义为单独的图像对象。

Use the following properties and methods to edit the hatch patterns:

下列属性和方法用于编辑填充图案:

GradientAngle

Specifies the gradient angle of the hatch. 指定填充的渐变色角度

GradientName

Returns the gradient name of the hatch. 返回填充的渐变色名称

GradientShift

Specifies the gradient shift of the hatch. 指定填充的渐变插值

GradientType

Returns the gradient type of the hatch. 返回填充的渐变色类型

PatternAngle

Specifies the angle of the hatch pattern. 指定填充图案的角度

PatternDouble

Specifies if the user-defined hatch is double-hatched. 指定用户自定义填充是否为双填充?

PatternName

Returns the hatch pattern name of the hatch. (Use the SetHatchPattern method to set the hatch pattern name and type of the hatch.) 返回填充图案的名称(使用SetHatchPattern方法设置填充的名称和类型)

PatternScale

Specifies the hatch pattern scale. 指定填充比例

PatternSpace

Specifies the user-defined hatch pattern spacing. 指定用户自定义填充的间隔

PatternType

Returns the hatch pattern type of the hatch. (Use the SetHatchPattern method to set the hatch pattern name and type of the hatch.) 返回填充图案的类型(使用SetHatchPattern方法设置填充的名称和类型)

SetGradient

Sets the gradient type and name for the hatch. 设置渐变填充的名称和类型

SetHatchPattern

Sets the pattern type and name for the hatch. 设置填充的名称和类型

Change the pattern spacing of a hatch 修改填充图案的间距

This example creates a hatch. It then adds two to the current pattern spacing for the hatch.

本例创建一个图案填充,然后将该填充图案的间距加2。

 

VB.NET

Imports Autodesk.AutoCAD.Runtime

Imports Autodesk.AutoCAD.ApplicationServices

Imports Autodesk.AutoCAD.DatabaseServices

Imports Autodesk.AutoCAD.Geometry

 

<CommandMethod("EditHatchPatternScale")> _

Public Sub EditHatchPatternScale()

  '' Get the current document and database

  Dim acDoc As Document = Application.DocumentManager.MdiActiveDocument

  Dim acCurDb As Database = acDoc.Database

 

  '' Start a transaction

  Using acTrans As Transaction = acCurDb.TransactionManager.StartTransaction()

 

      '' Open the Block table for read

      Dim acBlkTbl As BlockTable

      acBlkTbl = acTrans.GetObject(acCurDb.BlockTableId, _

                                   OpenMode.ForRead)

 

      '' Open the Block table record Model space for write

      Dim acBlkTblRec As BlockTableRecord

      acBlkTblRec = acTrans.GetObject(acBlkTbl(BlockTableRecord.ModelSpace), _

                                      OpenMode.ForWrite)

 

      '' Create a circle object for the boundary of the hatch

      Dim acCirc As Circle = New Circle()

      acCirc.Center = New Point3d(5, 3, 0)

      acCirc.Radius = 3

 

      acBlkTblRec.AppendEntity(acCirc)

      acTrans.AddNewlyCreatedDBObject(acCirc, True)

 

      '' Adds the arc and line to an object id collection

      Dim acObjIdColl As ObjectIdCollection = New ObjectIdCollection()

      acObjIdColl.Add(acCirc.ObjectId)

 

      '' Create the hatch object and append it to the block table record

      Dim acHatch As Hatch = New Hatch()

      acBlkTblRec.AppendEntity(acHatch)

      acTrans.AddNewlyCreatedDBObject(acHatch, True)

 

      '' Set the properties of the hatch object

      '' Associative must be set after the hatch object is appended to the

      '' block table record and before AppendLoop

      acHatch.SetHatchPattern(HatchPatternType.PreDefined, "ANSI31")

      acHatch.Associative = True

      acHatch.AppendLoop(HatchLoopTypes.Outermost, acObjIdColl)

 

      '' Evaluate the hatch

      acHatch.EvaluateHatch(True)

 

      '' Increase the pattern scale by 2 and re-evaluate the hatch

      acHatch.PatternScale = acHatch.PatternScale + 2

      acHatch.SetHatchPattern(acHatch.PatternType, acHatch.PatternName)

      acHatch.EvaluateHatch(True)

 

      '' Save the new object to the database

      acTrans.Commit()

  End Using

End Sub

 

C#

using Autodesk.AutoCAD.Runtime;

using Autodesk.AutoCAD.ApplicationServices;

using Autodesk.AutoCAD.DatabaseServices;

using Autodesk.AutoCAD.Geometry;

 

[CommandMethod("EditHatchPatternScale")]

public static void EditHatchPatternScale()

{

  // Get the current document and database

  Document acDoc = Application.DocumentManager.MdiActiveDocument;

  Database acCurDb = acDoc.Database;

 

  // Start a transaction

  using (Transaction acTrans = acCurDb.TransactionManager.StartTransaction())

  {

      // Open the Block table for read

      BlockTable acBlkTbl;

      acBlkTbl = acTrans.GetObject(acCurDb.BlockTableId,

                                   OpenMode.ForRead) as BlockTable;

 

      // Open the Block table record Model space for write

      BlockTableRecord acBlkTblRec;

      acBlkTblRec = acTrans.GetObject(acBlkTbl[BlockTableRecord.ModelSpace],

                                      OpenMode.ForWrite) as BlockTableRecord;

 

      // Create a circle object for the boundary of the hatch

      Circle acCirc = new Circle();

      acCirc.Center = new Point3d(5, 3, 0);

      acCirc.Radius = 3;

 

      acBlkTblRec.AppendEntity(acCirc);

      acTrans.AddNewlyCreatedDBObject(acCirc, true);

 

      // Adds the circle to an object id collection

      ObjectIdCollection acObjIdColl = new ObjectIdCollection();

      acObjIdColl.Add(acCirc.ObjectId);

 

      // Create the hatch object and append it to the block table record

      Hatch acHatch = new Hatch();

      acBlkTblRec.AppendEntity(acHatch);

      acTrans.AddNewlyCreatedDBObject(acHatch, true);

 

      // Set the properties of the hatch object设置填充对象属性

      // Associative must be set after the hatch object is appended to the block table record and before AppendLoop

      // 关联属性必须在将填充对象添加到块表记录之后、执行AppendLoop之前设置

      acHatch.SetHatchPattern(HatchPatternType.PreDefined, "ANSI31");

      acHatch.Associative = true;

      acHatch.AppendLoop(HatchLoopTypes.Outermost, acObjIdColl);

 

      // Evaluate the hatch计算填充

      acHatch.EvaluateHatch(true);

 

      // Increase the pattern scale by 2 and re-evaluate the hatch填充图案的比例加2,重新计算填充

      acHatch.PatternScale = acHatch.PatternScale + 2;

      acHatch.SetHatchPattern(acHatch.PatternType, acHatch.PatternName);

      acHatch.EvaluateHatch(true);

 

      // Save the new object to the database保存到数据库

      acTrans.Commit();

  }

}

 

VBA/ActiveX Code Reference

Sub EditHatchPatternScale()

    Dim hatchObj As AcadHatch

    Dim patternName As String

    Dim PatternType As Long

    Dim bAssociativity As Boolean

 

    ' Define the hatch

    patternName = "ANSI31"

    PatternType = 0

    bAssociativity = True

 

    ' Create the associative Hatch object

    Set hatchObj = ThisDrawing.ModelSpace. _

                       AddHatch(PatternType, patternName, bAssociativity)

 

    ' Create the outer loop for the hatch.

    Dim outerLoop(0 To 0) As AcadEntity

    Dim center(0 To 2) As Double

    Dim radius As Double

    center(0) = 5

    center(1) = 3

    center(2) = 0

    radius = 3

    Set outerLoop(0) = ThisDrawing.ModelSpace. _

                           AddCircle(center, radius)

    hatchObj.AppendOuterLoop (outerLoop)

    hatchObj.Evaluate

 

    ' Change the scale of the hatch pattern by

    ' adding 2 to the current scale

    hatchObj.patternScale = hatchObj.patternScale + 2

    hatchObj.Evaluate

    ThisDrawing.Regen True

End Sub

 

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值